#ifndef MPIPE_API_COMMAND_H
#define MPIPE_API_COMMAND_H

#include "mpipe_types.h"

// параметры команды для обмена SDP
typedef struct mpipe_command_sdp_params_t
{
    enum mpipe_peer_type_t          peer_type;  // тип пира: local, remote
    enum mpipe_sdp_type_t           sdp_type;   // тип SDP: offe, answer
    const char*                     sdp;        // строка в формате SDP

} mpipe_command_sdp_params_t;

// параметры команды для пользовательских данных
typedef struct mpipe_command_data_params_t
{
    const void*                     data;       // указатель на данные
    uint32_t                        size;       // размер данных

} mpipe_command_data_params_t;

// общая структура команды
typedef struct mpipe_command_t
{
    enum mpipe_command_id_t         command_id; // ID-команды: sdp, data
    union
    {
        mpipe_command_sdp_params_t  sdp;        // Параметры для SDP
        mpipe_command_data_params_t data;       // Параметры пользовательских данных
    }                               params;

} mpipe_command_t;



#endif // MPIPE_API_COMMAND_H
