#ifndef MPIPE_API_LOG_H
#define MPIPE_API_LOG_H

#include "mpipe_common.h"
#include "mpipe_types.h"

EXTERN_C_BEGIN

// структура с информацией о сообщении для логирования
typedef struct mpipe_log_message_t
{
    mpipe_log_level_t   level;              // уровень важности сообщения
    mpipe_timestamp_t   timestamp;          // метка времени (в наносекунды с начала эпохи)
    const char*         thread_name;        // имя потока
    const char*         src;                // путь к файлу исхзодных текстов
    int32_t             line;               // номер стрки в файле исходных тестов
    const char*         message;            // собственно сообщение для логирования
} mpipe_log_message_t;

typedef void (*mpipe_cb_log_t)(const struct mpipe_log_message_t* log_message);


EXTERN_C_END

#endif // MPIPE_API_LOG_H
