#ifndef MPIPE_API_MEDIA_FRAME_H
#define MPIPE_API_MEDIA_FRAME_H

#include "mpipe_media_format.h"

EXTERN_C_BEGIN

// блок общей информации медиафрейма
typedef struct mpipe_frame_info_t
{
    mpipe_frame_id_t            id;             // идентификатор фрейма (необязательный параметр)
    mpipe_timestamp_t           timestamp;      // метка времени в RTP нотации (в отсчетах SampleRate)
    enum mpipe_frame_type_t     type;           // тип фрейма: ключевой/предсказываемый
    mpipe_timestamp_t           abs_timestamp;  // метка вреемений в абслютных единицах с наносекундной точностью (необязательный параметр)

} mpipe_frame_info_t;

// общий описатель фрейма
typedef struct mpipe_media_frame_t
{
    struct mpipe_frame_info_t   frame_info;     // информация о фрейме
    struct mpipe_media_format_t media_format;   // формат фрейма
    struct mpipe_data_t         frame_data;     // полезные данные

} mpipe_media_frame_t;


EXTERN_C_END

#endif // MPIPE_API_MEDIA_FRAME_H
