#ifndef MPIPE_API_TYPES_H
#define MPIPE_API_TYPES_H

#include "mpipe_defs.h"

EXTERN_C_BEGIN

#include <stdint.h>

typedef enum mpipe_media_type_t
{
    mpipe_media_type_undefined = 0,
    mpipe_media_type_audio,
    mpipe_media_type_video,
    mpipe_media_type_data,
    mpipe_media_type_custom
} mpipe_media_type_t;

typedef enum mpipe_converter_type_t
{
    mpipe_converter_type_undefined = 0,
    mpipe_converter_type_converter,
    mpipe_converter_type_encoder,
    mpipe_converter_type_decoder,
    mpipe_converter_type_smart
} mpipe_converter_type_t;

typedef enum mpipe_audio_format_id_t
{
    mpipe_audio_format_id_undefined = 0,
    mpipe_audio_format_id_pcm8,
    mpipe_audio_format_id_pcm16,
    mpipe_audio_format_id_pcm32,
    mpipe_audio_format_id_float32,
    mpipe_audio_format_id_float64,
    mpipe_audio_format_id_pcm8p,
    mpipe_audio_format_id_pcm16p,
    mpipe_audio_format_id_pcm32p,
    mpipe_audio_format_id_float32p,
    mpipe_audio_format_id_float64p,
    mpipe_audio_format_id_pcma,
    mpipe_audio_format_id_pcmu,
    mpipe_audio_format_id_opus,
    mpipe_audio_format_id_aac
} mpipe_audio_format_id_t;


typedef enum mpipe_video_format_id_t
{
    mpipe_video_format_id_undefined = 0,
    mpipe_video_format_id_yuv420p,
    mpipe_video_format_id_yuv422p,
    mpipe_video_format_id_yuv444p,
    mpipe_video_format_id_yuv411p,
    mpipe_video_format_id_yuyv,
    mpipe_video_format_id_uyvy,
    mpipe_video_format_id_yuv410,
    mpipe_video_format_id_nv12,
    mpipe_video_format_id_nv21,
    mpipe_video_format_id_nv16,
    mpipe_video_format_id_bgr555,
    mpipe_video_format_id_bgr555x,
    mpipe_video_format_id_bgr565,
    mpipe_video_format_id_bgr565x,
    mpipe_video_format_id_rgb555,
    mpipe_video_format_id_rgb555x,
    mpipe_video_format_id_rgb565,
    mpipe_video_format_id_rgb565x,
    mpipe_video_format_id_bgr8,
    mpipe_video_format_id_rgb8,
    mpipe_video_format_id_bgr24,
    mpipe_video_format_id_rgb24,
    mpipe_video_format_id_bgr32,
    mpipe_video_format_id_rgb32,
    mpipe_video_format_id_abgr32,
    mpipe_video_format_id_argb32,
    mpipe_video_format_id_bgra32,
    mpipe_video_format_id_rgba32,
    mpipe_video_format_id_gray8,
    mpipe_video_format_id_gray16,
    mpipe_video_format_id_gray16x,
    mpipe_video_format_id_sbggr8,
    mpipe_video_format_id_sgbrg8,
    mpipe_video_format_id_sgrbg8,
    mpipe_video_format_id_srggb8,
    mpipe_video_format_id_png,
    mpipe_video_format_id_jpeg,
    mpipe_video_format_id_mjpeg,
    mpipe_video_format_id_gif,
    mpipe_video_format_id_h265,
    mpipe_video_format_id_h264,
    mpipe_video_format_id_h263,
    mpipe_video_format_id_h263p,
    mpipe_video_format_id_h261,
    mpipe_video_format_id_vp8,
    mpipe_video_format_id_vp9,
    mpipe_video_format_id_mpeg4,
    mpipe_video_format_id_cpia
} mpipe_video_format_id_t;

typedef enum mpipe_device_state_t
{
    mpipe_device_state_undefined = 0,
    mpipe_device_state_ready,
    mpipe_device_state_create,
    mpipe_device_state_opening,
    mpipe_device_state_open,
    mpipe_device_state_starting,
    mpipe_device_state_started,
    mpipe_device_state_connecting,
    mpipe_device_state_connected,
    mpipe_device_state_stopping,
    mpipe_device_state_stopped,
    mpipe_device_state_disconnecting,
    mpipe_device_state_disconnected,
    mpipe_device_state_closing,
    mpipe_device_state_closed,
    mpipe_device_state_failed,
    mpipe_device_state_remove
} mpipe_device_state_t;

typedef enum mpipe_device_control_id_t
{
    mpipe_device_control_id_undefined = 0,
    mpipe_device_control_id_open,
    mpipe_device_control_id_close,
    mpipe_device_control_id_start,
    mpipe_device_control_id_stop,
    mpipe_device_control_id_command,
    mpipe_device_control_id_custom
} mpipe_device_control_id_t;

typedef enum mpipe_device_type_t
{
    mpipe_device_type_undefined,
    mpipe_device_type_input,
    mpipe_device_type_output,
    mpipe_device_type_webrtc,
    mpipe_device_type_custom
} mpipe_device_type_t;

typedef enum mpipe_sdp_type_t
{
    mpipe_sdp_type_undefined = 0,
    mpipe_sdp_type_offer,
    mpipe_sdp_type_answer
} mpipe_sdp_type_t;

typedef enum mpipe_peer_type_t
{
    mpipe_peer_type_local = 0,
    mpipe_peer_type_remote
} mpipe_peer_type_t;

typedef enum mpipe_command_id_t
{
    mpipe_command_id_undefined = 0,
    mpipe_command_id_sdp,
    mpipe_command_id_data
} mpipe_command_id_t;

typedef enum mpipe_track_direction_t
{
    mpipe_track_direction_undefined = -1,
    mpipe_track_direction_sendrecv,
    mpipe_track_direction_sendonly,
    mpipe_track_direction_recvonly,
    mpipe_track_direction_inactive
} mpipe_track_direction_t;

typedef enum mpipe_stream_direction_t
{
    mpipe_stream_direction_undefined = 0,
    mpipe_stream_direction_input,
    mpipe_stream_direction_output
} mpipe_stream_direction_t;

typedef enum mpipe_stream_state_t
{
    mpipe_stream_state_undefined = 0,
    mpipe_stream_state_add,
    mpipe_stream_state_update,
    mpipe_stream_state_remove
} mpipe_stream_state_t;

typedef enum mpipe_frame_type_t
{
    mpipe_frame_type_slice          = 0,
    mpipe_frame_type_key            = 1,
    mpipe_frame_type_raw            = mpipe_frame_type_slice
} mpipe_frame_type_t;

typedef enum mpipe_object_type_t
{
    mpipe_object_type_undefined     = -1,
    mpipe_object_type_device        = 0,
    mpipe_object_type_converter     = 1
} mpipe_object_type_t;

typedef enum mpipe_result_t
{
    mpipe_result_ok                 = 0,
    mpipe_result_error_not_found    = -1,
    mpipe_result_error_not_req      = -2,
    mpipe_result_error_params       = -3,
    mpipe_result_error_already_use  = -4,
    mpipe_result_error_not_impl     = -5,
    mpipe_result_error_not_init     = -6,
    mpipe_result_error_undefined    = -100
} mpipe_result_t;

typedef enum mpipe_log_level_t
{
    mpipe_log_level_trace,
    mpipe_log_level_debug,
    mpipe_log_level_info,
    mpipe_log_level_warning,
    mpipe_log_level_error,
    mpipe_log_level_fatal

} mpipe_log_level_t;

typedef int32_t         mpipe_handle_t;
typedef int32_t         mpipe_id_t;
typedef int32_t         mpipe_bool_t;
typedef const char*     mpipe_string_t;

typedef mpipe_id_t      mpipe_stream_id_t;
typedef mpipe_id_t      mpipe_track_id_t;
typedef mpipe_id_t      mpipe_device_id_t;
typedef mpipe_id_t      mpipe_frame_id_t;

typedef int64_t         mpipe_timestamp_t;

#define MPIPE_ID_UNDEFINED          (-1)

#define MPIPE_HANDLE_UNDEFINED      MPIPE_ID_UNDEFINED
#define MPIPE_STREAM_ID_UNDEFINED   MPIPE_ID_UNDEFINED
#define MPIPE_TRACK_ID_UNDEFINED    MPIPE_ID_UNDEFINED
#define MPIPE_DEVICE_ID_UNDEFINED   MPIPE_ID_UNDEFINED
#define MPIPE_FRAME_ID_UNDEFINED    MPIPE_ID_UNDEFINED

#define MPIPE_TIMESTAMP_NULL        (0)
#define MPIPE_TIMESTAMP_INFINITE    (-1)

EXTERN_C_END

#endif // MPIPE_API_TYPES_H
