#ifndef MPIPE_I_MUTABLE_BUFFER_H
#define MPIPE_I_MUTABLE_BUFFER_H

#include <cstdint>

#include "i_mapped_buffer.h"

namespace mpipe
{

class i_mutable_buffer : public i_mapped_buffer
{
public:
    using u_ptr_t = std::unique_ptr<i_mutable_buffer>;
    using s_ptr_t = std::shared_ptr<i_mutable_buffer>;

    // изменить размер буфера, возвращается новый размер буфера
    virtual std::size_t resize(std::size_t new_size) = 0;

    // добавить данные в буффер, возвращается новый размер буфера
    virtual std::size_t append(const i_data_object& data) = 0;
};

}

#endif // MPIPE_I_MUTABLE_BUFFER_H
