#ifndef MPIPE_I_COMMAND_SDP_H
#define MPIPE_I_COMMAND_SDP_H

#include "i_command.h"
#include "rtc/rtc_types.h"

namespace mpipe
{

class i_command_sdp : public i_command
{
public:
    using u_ptr_t = std::unique_ptr<i_command_sdp>;
    using s_ptr_t = std::shared_ptr<i_command_sdp>;

    virtual command_id_t command_id() const final override { return command_id_t::sdp; }
    virtual wrtc::peer_type_t peer_type() const = 0;
    virtual wrtc::sdp_type_t sdp_type() const = 0;
    virtual const std::string& sdp() const = 0;

    virtual i_command::u_ptr_t clone() const = 0;
};

}

#endif // MPIPE_I_COMMAND_SDP_H
