#ifndef MPIPE_I_DEVICE_H
#define MPIPE_I_DEVICE_H

#include "core/stream/i_media_stream.h"
#include "core/option/i_option.h"
#include "device_types.h"


namespace mpipe
{

class i_command;
class i_command_sink;
class i_device_params;

class i_device
{
public:

    class i_listener : public i_media_stream::i_listener
    {
    public:
        virtual void on_device_state(device_state_t state) = 0;
        virtual bool on_device_command(const i_command& command) = 0;
        // device handlers
    };

    using u_ptr_t = std::unique_ptr<i_device>;
    using s_ptr_t = std::shared_ptr<i_device>;

    virtual ~i_device() = default;

    virtual bool control(device_control_id_t control_id) = 0;

    virtual i_option::u_ptr_t get_params() const = 0;
    virtual i_media_stream* get_stream(stream_id_t stream_id
                                       , stream_direction_t direction) = 0;

    virtual void set_listener(i_device::i_listener* device_listener) = 0;


    virtual i_command_sink* command_sink() = 0;
    virtual device_type_t device_type() const = 0;
    virtual bool is_open() const = 0;
    virtual device_state_t state() const = 0;
};

}

#endif // MPIPE_I_DEVICE_H
