#ifndef MPIPE_I_DEVICE_OUTPUT_H
#define MPIPE_I_DEVICE_OUTPUT_H

#include "core/stream/stream_types.h"
#include "i_device.h"

namespace mpipe
{

class i_media_format;

class i_device_output : public i_device
{
public:
    using u_ptr_t = std::unique_ptr<i_device_output>;
    using s_ptr_t = std::shared_ptr<i_device_output>;

    virtual device_type_t device_type() const override final { return device_type_t::output; }
    virtual i_media_stream* add_stream(const i_media_format& format) = 0;
    virtual bool remove_streams() = 0;
    virtual std::size_t streams() const = 0;

};

}

#endif // MPIPE_I_DEVICE_OUTPUT_H
