#ifndef MPIPE_I_ENGINE_H
#define MPIPE_I_ENGINE_H

#include "device/i_device_factory.h"
#include "media/i_media_converter_factory.h"
#include "task/i_task_manager.h"
#include "task/i_worker_factory.h"
#include "time/i_timer_manager.h"


namespace mpipe
{

class i_engine
{
public:
    using u_ptr_t = std::unique_ptr<i_engine>;

    virtual ~i_engine() = default;

    static u_ptr_t create_engine(const i_option& params);

    virtual i_device_factory& device_factory() = 0;
    virtual i_media_converter_factory& converter_factory() = 0;
    virtual i_worker_factory& worker_factory() = 0;
    virtual i_task_manager& task_manager() = 0;
    virtual i_timer_manager& timer_manager() = 0;
};

}

#endif // MPIPE_I_ENGINE_H
