#ifndef MPIPE_FRAME_INFO_H
#define MPIPE_FRAME_INFO_H

#include "frame_types.h"
#include "core/time/time_types.h"

namespace mpipe
{

struct frame_info_t
{
    frame_id_t      frame_id;
    timestamp_t     frame_timestamp;
    bool            key_frame;
    timestamp_t     abs_timestamp;

    frame_info_t(frame_id_t frame_id = frame_id_undefined
                 , timestamp_t frame_timestamp = timestamp_null
                 , bool key_frame = false
                 , timestamp_t abs_timestamp = timestamp_null);

    bool operator == (const frame_info_t& other) const;
    bool operator != (const frame_info_t& other) const;
};

}

#endif // MPIPE_FRAME_INFO_H
