#ifndef MPIPE_I_MEDIA_CONVERTER_H
#define MPIPE_I_MEDIA_CONVERTER_H

#include "i_media_router.h"
#include "media_types.h"

namespace mpipe
{

class i_media_format;

class i_media_converter : public i_media_sink
{
public:
    using u_ptr_t = std::unique_ptr<i_media_converter>;
    using s_ptr_t = std::shared_ptr<i_media_converter>;

    virtual converter_type_t converter_type() const = 0;
    virtual const i_media_format& input_format() const = 0;
    virtual const i_media_format& output_format() const = 0;
    virtual void set_sink(i_media_sink* sink) = 0;

};

}

#endif // MPIPE_I_MEDIA_CONVERTER_H
