#ifndef MPIPE_I_MEDIA_CONVERTER_FACTORY_H
#define MPIPE_I_MEDIA_CONVERTER_FACTORY_H

#include "i_media_converter.h"

namespace mpipe
{

struct i_converter_params;
class i_option;

class i_media_converter_factory
{
public:
    using u_ptr_t = std::unique_ptr<i_media_converter_factory>;
    using s_ptr_t = std::shared_ptr<i_media_converter_factory>;

    virtual ~i_media_converter_factory() = default;
    virtual i_media_converter::u_ptr_t create_converter(const i_option& params
                                                        , const i_media_format& format) = 0;
};

}

#endif // MPIPE_I_MEDIA_CONVERTER_FACTORY_H
