#ifndef MPIPE_I_MEDIA_FORMAT_H
#define MPIPE_I_MEDIA_FORMAT_H

#include "media_types.h"
#include <memory>
#include <string>
#include <vector>

namespace mpipe
{

struct media_params_t;

class i_media_format
{
public:
    using u_ptr_t = std::unique_ptr<i_media_format>;
    using s_ptr_t = std::shared_ptr<i_media_format>;
    using u_array_t = std::vector<u_ptr_t>;
    using s_array_t = std::vector<s_ptr_t>;

    using options_t = std::string;
    virtual ~i_media_format() = default;

    virtual media_type_t media_type() const = 0;
    virtual bool is_encoded() const = 0;
    virtual bool is_convertable() const = 0;
    virtual i_media_format::u_ptr_t clone() const = 0;
    virtual bool is_equal(const i_media_format& other) const = 0;
    virtual bool is_compatible(const i_media_format& other) const = 0;
    virtual const media_params_t& params() const = 0;
    virtual bool is_valid() const = 0;
};

}

#endif // MPIPE_I_MEDIA_FORMAT_H
