#ifndef MPIPE_I_OPTION_H
#define MPIPE_I_OPTION_H

#include "option_types.h"
#include <memory>
#include <vector>

namespace mpipe
{

class i_option
{
public:
    using u_ptr_t = std::unique_ptr<i_option>;
    using s_ptr_t = std::shared_ptr<i_option>;
    using u_array_t = std::vector<u_ptr_t>;

    virtual ~i_option() = default;

    virtual option_type_t type() const = 0;
    virtual bool is_equal(const i_option& other) const = 0;
    virtual bool merge(const i_option& other) = 0;
    virtual i_option::u_ptr_t clone() const = 0;
};

}

#endif // MPIPE_I_OPTION_H
