#ifndef MPIPE_I_OPTION_OBJECT_H
#define MPIPE_I_OPTION_OBJECT_H

#include "i_option.h"
#include <string>
#include <vector>

namespace mpipe
{

using option_key_t = std::string;
using option_key_array_t = std::vector<option_key_t>;

class i_option_object : public i_option
{
public:
    using u_ptr_t = std::unique_ptr<i_option_object>;
    using s_ptr_t = std::shared_ptr<i_option_object>;

    virtual option_type_t type() const final { return option_type_t::object; }
    virtual const i_option* get(const option_key_t& key) const = 0;
    virtual i_option* get(const option_key_t& key) = 0;
    virtual bool set(const option_key_t& key
                     , i_option::u_ptr_t&& option_value) = 0;
    virtual option_key_array_t keys() const = 0;

};

}


#endif // MPIPE_I_OPTION_OBJECT_H
