#ifndef MPIPE_I_OPTION_VALUE_H
#define MPIPE_I_OPTION_VALUE_H

#include "i_option.h"
#include <memory>

namespace mpipe
{

template<typename T>
class i_option_value : public i_option
{
public:
    using u_ptr_t = std::unique_ptr<i_option_value<T>>;
    using s_ptr_t = std::shared_ptr<i_option_value<T>>;
    using u_array_t = std::vector<u_ptr_t>;

    virtual const T& get() const = 0;
    virtual T& get() = 0;
    virtual void set(const T& value) = 0;
    virtual void set(T&& value) = 0;
};

}

#endif // MPIPE_I_OPTION_VALUE_H
