#ifndef MPIPE_I_MEDIA_STREAM_H
#define MPIPE_I_MEDIA_STREAM_H

#include "core/media/media_types.h"
#include "core/stream/stream_types.h"

#include <memory>

namespace mpipe
{

class i_media_format;
class i_media_sink;
struct flow_stats_t;

class i_media_stream
{
public:
    class i_listener
    {
    public:
        virtual ~i_listener() = default;
        virtual void on_media_stream(i_media_stream* stream
                                     , stream_state_t state) = 0;
    };

    using u_ptr_t = std::unique_ptr<i_media_stream>;
    using s_ptr_t = std::shared_ptr<i_media_stream>;

    virtual ~i_media_stream() = default;
    virtual stream_id_t stream_id() const = 0;
    virtual std::string name() const = 0;
    virtual const i_media_format& format() const = 0;
    virtual stream_direction_t direction() const = 0;
    virtual bool get_stats(flow_stats_t& flow_stats) const = 0;
    virtual i_media_sink* media_input() = 0;
    virtual bool set_media_output(i_media_sink* source) = 0;
    virtual bool is_enabled() const = 0;
    virtual bool set_enabled(bool enabled) = 0;
};

}

#endif // MPIPE_I_MEDIA_STREAM_H
