#ifndef MPIPE_STREAM_TYPES_H
#define MPIPE_STREAM_TYPES_H

#include <cstdint>

namespace mpipe
{

enum class stream_direction_t
{
    undefined = 0,
    input,
    output
};

enum class stream_state_t
{
    undefined = 0,
    add,
    update,
    remove
};

using stream_id_t = std::int32_t;
using track_id_t = std::int32_t;

constexpr stream_id_t undefined_stream_id = -1;
constexpr track_id_t undefined_track_id = -1;

}

#endif // MPIPE_STREAM_TYPES_H
