#ifndef MPIPE_I_TASK_H
#define MPIPE_I_TASK_H

#include "task_types.h"
#include <memory>

namespace mpipe
{

class i_task
{
public:

    using u_ptr_t = std::unique_ptr<i_task>;
    using s_ptr_t = std::shared_ptr<i_task>;

    virtual ~i_task() = default;
    virtual task_id_t task_id() const = 0;
    virtual bool wait() = 0;
    virtual void cancel() = 0;
    virtual task_state_t state() const = 0;
};

}

#endif // MPIPE_I_TASK_H
