#ifndef MPIPE_TASK_I_WORKER_H
#define MPIPE_TASK_I_WORKER_H

#include "task_types.h"
#include <memory>

namespace mpipe
{

class i_worker
{
public:
    using u_ptr_t = std::unique_ptr<i_worker>;
    using s_ptr_t = std::shared_ptr<i_worker>;

    virtual ~i_worker() = default;
    virtual void post(task_handler_t&& handler) = 0;

    virtual bool start() = 0;
    virtual bool stop() = 0;
    virtual bool is_running() const = 0;

    virtual bool wait() = 0;
    virtual bool run() = 0;

    virtual const std::string& name() const = 0;
};

}

#endif // MPIPE_TASK_I_WORKER_H
