#ifndef MPIPE_LOG_I_LOGGER_H
#define MPIPE_LOG_I_LOGGER_H

#include "log_types.h"
#include <cstdint>
#include <memory>
#include <functional>

namespace mpipe::log
{

struct log_message_t;

class i_logger
{
public:
    class i_sink
    {
    public:
        using u_ptr_t = std::unique_ptr<i_sink>;
        using s_ptr_t = std::shared_ptr<i_sink>;

        virtual ~i_sink() = default;
        virtual bool on_log(const log_message_t& message) = 0;
    };

    using u_ptr_t = std::unique_ptr<i_logger>;
    using s_ptr_t = std::shared_ptr<i_logger>;

    virtual ~i_logger() = default;

    virtual log_level_t level() const = 0;
    virtual void set_log_level(log_level_t level) = 0;
    virtual void set_sink(i_sink* sink) = 0;
    virtual bool log(const log_message_t& message) = 0;
};

}

#endif // MPIPE_LOG_I_LOGGER_H
