#ifndef MPIPE_WRTC_I_PEER_CONNECTION_FACTORY_H
#define MPIPE_WRTC_I_PEER_CONNECTION_FACTORY_H

#include "i_peer_connection.h"

namespace mpipe::wrtc
{

struct peer_connection_params_t;

class i_peer_connection_factory
{
public:
    using u_ptr_t = std::unique_ptr<i_peer_connection_factory>;
    using s_ptr_t = std::shared_ptr<i_peer_connection_factory>;

    virtual ~i_peer_connection_factory() = default;

    virtual i_peer_connection::u_ptr_t create_peer_connection(const peer_connection_params_t& peer_params) = 0;
};

}

#endif // MPIPE_WRTC_I_PEER_CONNECTION_FACTORY_H
