#ifndef MPIPE_I_RTC_SESSION_H
#define MPIPE_I_RTC_SESSION_H

#include "rtc_types.h"
#include "i_rtc_track.h"
#include <memory>

namespace mpipe::wrtc
{

class i_rtc_session
{
public:
    using u_ptr_t = std::unique_ptr<i_rtc_session>;
    using s_ptr_t = std::shared_ptr<i_rtc_session>;

    virtual ~i_rtc_session() = default;
    virtual media_type_t media_type() const = 0;
    virtual rtc_track_direction_t direction() const = 0;
    virtual std::size_t id() const = 0;
    virtual std::string mid() const = 0;
    virtual i_rtc_track* input_track() = 0;
    virtual i_rtc_track* output_track() = 0;
};

}

#endif // MPIPE_I_RTC_SESSION_H
