#ifndef MPIPE_WRTC_I_RTC_TRACK_H
#define MPIPE_WRTC_I_RTC_TRACK_H

#include "core/media/media_types.h"
#include "core/stream/stream_types.h"
#include "core/media/i_media_source.h"
#include "track_stats.h"
#include <memory>
#include <string>


namespace mpipe::wrtc
{

class i_rtc_session;

class i_rtc_track
{
public:
    using u_ptr_t = std::unique_ptr<i_rtc_track>;
    using s_ptr_t = std::shared_ptr<i_rtc_track>;

    virtual i_media_sink* media_input() = 0;
    virtual bool set_media_output(i_media_sink* source) = 0;

    virtual bool set_enabled(bool enabled) = 0;
    virtual bool is_enabled() const = 0;
    virtual const i_rtc_session& session() const = 0;
    virtual stream_direction_t direction() const = 0;
    virtual track_stats_t stats() const = 0;
    virtual std::string track_id() const = 0;
};

}

#endif // MPIPE_WRTC_I_RTC_TRACK_H
