#ifndef MPIPE_RTC_PEER_BITRATE_PARAMS_H
#define MPIPE_RTC_PEER_BITRATE_PARAMS_H

#include <cstdint>

namespace mpipe::wrtc
{

struct peer_bitrate_params_t
{
    std::uint32_t   start_bitrate;
    std::uint32_t   min_bitrate;
    std::uint32_t   max_bitrate;

    static const peer_bitrate_params_t& default_params();

    peer_bitrate_params_t(std::uint32_t start_bitrate = 0
                          , std::uint32_t min_bitrate = 0
                          , std::uint32_t max_bitrate = 0);

    bool operator == (const peer_bitrate_params_t& other) const;
    bool operator != (const peer_bitrate_params_t& other) const;

    bool is_dafault() const;
};

}

#endif // MPIPE_RTC_PEER_BITRATE_PARAMS_H
