#ifndef MPIPE_WRTC_PEER_CONNECTION_PARAMS_H
#define MPIPE_WRTC_PEER_CONNECTION_PARAMS_H

#include "peer_connection_params.h"
#include "track_params.h"

namespace mpipe::wrtc
{

struct peer_connection_params_t
{
    struct ice_servers_t
    {
        using array_t = std::vector<ice_servers_t>;
        std::string     url;
        std::string     user;
        std::string     password;

        ice_servers_t(const std::string_view& url = {}
                      , const std::string_view& user = {}
                      , const std::string_view& password = {});
    };


    ice_servers_t::array_t      ice_servers;
    bool                        disable_tcp;
    bool                        disable_local_networks;
    std::string                 data_channel;

    std::uint16_t               min_rtp_port;
    std::uint16_t               max_rtp_port;

    track_params_t::array_t     tracks;

    peer_connection_params_t(const ice_servers_t::array_t& ice_servers = {}
                             , bool disable_tcp = false
                             , bool disable_local_networks = false
                             , const std::string_view& data_channel = {}
                             , std::uint16_t min_rtp_port = 0
                             , std::uint16_t max_rtp_port = 0
                             , const track_params_t::array_t& tracks = {});
};

}

#endif // MPIPE_WRTC_PEER_CONNECTION_PARAMS_H
