#ifndef MPIPE_WRTC_TYPES_H
#define MPIPE_WRTC_TYPES_H

namespace mpipe::wrtc
{


// https://w3c.github.io/webrtc-pc/#dom-rtcpeerconnectionstate
enum class connection_state_t
{
    undefined = -1,
    ready,
    connecting,
    connected,
    disconnected,
    failed,
    closed
};

// https://w3c.github.io/webrtc-pc/#dom-rtciceconnectionstate
enum class ice_connection_state_t
{
    undefined = -1,
    ready,
    checking,
    connected,
    completed,
    failed,
    disconnected,
    closed,
    max
};

// https://w3c.github.io/webrtc-pc/#dom-rtcicegatheringstate
enum class ice_gathering_state_t
{
    undefined = -1,
    ready,
    gathering,
    complete
};

// https://www.w3.org/TR/webrtc/#idl-def-rtcdatachannelstate
enum class data_channel_state_t
{
    undefined = -1,
    connecting,
    open,
    closing,
    closed
};

enum class signalling_state_t
{
    undefined = -1,
    stable,
    have_local_offer,
    have_local_pre_answer,
    have_remote_offer,
    have_remote_pre_answer,
    closed
};

enum class sdp_type_t
{
    undefined = 0,
    offer,
    answer
};

enum class peer_type_t
{
    local,
    remote
};

enum class rtc_track_direction_t
{
    undefined = -1,
    sendrecv,
    sendonly,
    recvonly,
    inactive
};

}

#endif // MPIPE_WRTC_TYPES_H
