#ifndef MPIPE_RTC_TRACK_STATE_H
#define MPIPE_RTC_TRACK_STATE_H

#include "core/time/time_types.h"
#include <vector>

namespace mpipe::wrtc
{

struct track_stats_t
{
    std::size_t         id = 0;
    std::size_t         total_bytes = 0;
    std::size_t         total_packets = 0;
    std::size_t         total_frames = 0;
    std::size_t         bitrate = 0;
    std::size_t         frame_rate = 0;
    std::size_t         packet_lost = 0;
    double              jitter = 0;
    double              rtt = 0;
    timestamp_t         timestamp = timestamp_null;


    using array_t = std::vector<track_stats_t>;

    track_stats_t();

    bool operator == (const track_stats_t& other) const;
    bool operator != (const track_stats_t& other) const;

    void reset();
    void update_timestamp();
};

}

#endif // MPIPE_RTC_TRACK_STATE_H
