#ifndef MPIPE_AUDIO_SPLITTER_H
#define MPIPE_AUDIO_SPLITTER_H

#include "core/media/audio_info.h"
#include "utils/data/data_splitter.h"

namespace mpipe::utils::media
{

class audio_frame_splitter
{
    using data_splitter = data::data_splitter;
    using data_fragment_queue_t = data::data_fragment_queue_t;
    using splitters_t = std::vector<data_splitter>;

    audio_info_t            m_format;
    std::uint32_t           m_frame_size;
    splitters_t             m_splitters;
public:

    audio_frame_splitter();
    audio_frame_splitter(const audio_info_t& format
                         , std::uint32_t frame_size);

    void setup(const audio_info_t& format
               , std::uint32_t frame_size);

    void reset();

    const audio_info_t& format() const;
    std::uint32_t frame_size() const;
    std::size_t buffered_samples() const;

    data_fragment_queue_t push_frame(const void* data
                                    , std::size_t size);


};
}

#endif // MPIPE_AUDIO_SPLITTER_H
