#ifndef MPL_ENUM_SERIALIZE_DEFS_H
#define MPL_ENUM_SERIALIZE_DEFS_H

#include "convert_utils.h"
#include "convert_utils.h"
#include "common_utils.h"
#include "option/option_utils.h"
#include "option/option_writer.h"

namespace mpipe
{

namespace detail
{

template<typename E>
inline bool serialize(i_option& option, const E& enum_value)
{
    return utils::option::serialize(option
                                    , utils::conv::to_string(enum_value));
}

template<typename E>
inline i_option::u_ptr_t serialize(const E& enum_value)
{
    return utils::option::serialize(utils::conv::to_string(enum_value));
}


template<typename E>
inline bool deserialize(const i_option& option, E& enum_value)
{
    std::string string_value;
    return utils::option::deserialize(option
                                      , string_value)
            && utils::conv::convert(string_value, enum_value);
}

}

#define __declare_enum_serializer(enum_type)\
    template<> bool utils::option::serialize(i_option& option, const enum_type& enum_value) { return mpipe::detail::serialize(option, enum_value); }\
    template<> i_option::u_ptr_t utils::option::serialize(const enum_type& enum_value) { return mpipe::detail::serialize(enum_value); }\
    template<> bool utils::option::deserialize(const i_option& option, enum_type& enum_value) { return mpipe::detail::deserialize(option, enum_value); }\
    template<> option_type_t utils::option::get_value_type<enum_type>() { return option_type_t::string; }
}

#endif // WBS_ENUM_SERIALIZE_DEFS_H
