#ifndef MPIPE_OPTION_UTILS_H
#define MPIPE_OPTION_UTILS_H

#include "core/option/option_types.h"
#include "core/option/i_option_value.h"

#include <vector>

namespace mpipe::utils::option
{

template<typename T>
option_type_t get_value_type();

i_option::u_ptr_t create_option(option_type_t option_type);

template<typename T>
i_option::u_ptr_t serialize(const T& value);

template<typename T>
bool serialize(i_option& option, const T& value);


template<typename T>
bool deserialize(const i_option& option, T& value);

// vector

/*
template<typename T>
i_option::u_ptr_t serialize(const std::vector<T>& values)
{
    if (auto p = create_option(option_type_t::array))
    {
        if (serialize(*p, values))
        {
            return p;
        }
    }

    return nullptr;
}

template<typename T>
bool serialize(i_option& option, const std::vector<T>& values)
{
    if (option.type() == option_type_t::array)
    {
        auto& array_values = static_cast<i_option_value<i_option::u_array_t>&>(option).get();
        array_values.clear();
        for (const auto& v : array_values)
        {
            if (auto p = serialize(v))
            {
                array_values.emplace_back(std::move(p));
            }
        }

        return !array_values.empty();
    }

    return false;
}

template<typename T>
bool deserialize(const i_option& option, std::vector<T>& values)
{
    if (option.type() == option_type_t::array)
    {
        values.clear();
        for (const auto& p : static_cast<const i_option_value<i_option::u_array_t>&>(option).get())
        {
            T v = {};
            if (deserialize(*p, v))
            {
                values.emplace_back(std::move(v));
            }
        }

        return !values.empty();
    }

    return false;
}
*/

}

#endif // MPIPE_OPTION_UTILS_H
