#ifndef MPIPE_UTILS_OPTION_WRITER_H
#define MPIPE_UTILS_OPTION_WRITER_H

#include "option_reader.h"

namespace mpipe::utils::option
{

class option_writer : public option_reader
{
public:
    option_writer(i_option& root);

    i_option* get_child(const std::string& key);

    bool set(const std::string& key, i_option::u_ptr_t&& option);

    template<typename T>
    inline bool set(const std::string& key, const T& value)
    {
        if (auto v = serialize(value))
        {
            return set(key, std::move(v));
        }

        return false;
    }

private:
    i_option& root();
};

}

#endif // MPIPE_UTILS_OPTION_WRITER_H
